<?php

ini_set("memory_limit","512M");
set_time_limit(0);

//fprintf(STDERR,"Offline tool allowing to compute the vertices of the flux cone\n");
//fprintf(STDERR,"Notice that it is an approximate computation. If you do not test\n");
//fprintf(STDERR,"enough random objective, you may miss some vertices.\n");
//fprintf(STDERR,"The total number of tested objectives is nb_processes * nb_objectives_per_process.\n");
//fprintf(STDERR,"You will be asked to define both values\n");
//fprintf(STDERR,"--------------------------------------------------------------\n");
//fprintf(STDERR,"1) Launch the computation\n");
//fprintf(STDERR,"2) Verify if the computation of vertices has finished\n");
//fprintf(STDERR,"3) Group the computed vertices\n");
//fprintf(STDERR,"4) Computes the AIO Min/Max\n");
//fprintf(STDERR,"5) Verify if the computation of AIO Min/Max has finished\n");
//fprintf(STDERR,"6) Group the computed AIO Min/Max\n");
//fprintf(STDERR,"NB: you must do 1), wait until all the vertices are computed and then 3) and finally 4)\n");
//fprintf(STDERR,"Your choice ?");
$choice=$argv[1]; //trim(fgets(STDIN,4096));

switch ($choice) {
case "1":
//fprintf(STDERR,"You must provide a .mdl file. Filename=");
$filename=$argv[2];//trim(fgets(STDIN,4096));
//fprintf(STDERR,"Are you on a SGI based cluster ? [y/N] ");
$answer=$argv[3];//trim(fgets(STDIN,4096));
$answer=($answer == "y" || $answer == "Y")?"Y":"N";


if ($answer == "Y") {
	system("rm solutions_calculees*.txt pbtosolve.tmp\n");
//	fprintf(STDERR,"Maximum number of nodes used [100 is good] = ");
	$maxtirages=$argv[4];//trim(fgets(STDIN,4096));
//	fprintf(STDERR,"Number of objectives per nodes [10 is good] = ");
	$nbtirages=$argv[5];//trim(fgets(STDIN,4096));

	for($i=1; $i<=$maxtirages; $i++) {
		$fd=fopen("script".$i.".sh","w");
		fputs($fd,"export PATH=\$PATH:/softs/local/php/current/bin\n");
		fputs($fd,"cd ".exec("pwd")."\n");
		fputs($fd,"php -q ./unsommet.php ".$filename." ".$i." ".$nbtirages."\n");
		fclose($fd);
		system(sprintf("qsub -e /dev/null script%d.sh\n",$i));
		// system(sprintf("rm script%d.sh\n",$i));
	}
} else {
	system("rm solutions_calculees*.txt pbtosolve.tmp script*.sh\n");
//	fprintf(STDERR,"Maximum number of processes used (coarse grain parallization for a multicore computer) [20 is good] = ");
	$maxtirages=$argv[4];//trim(fgets(STDIN,4096));
//	fprintf(STDERR,"Number of objectives per processes [10 is good] = ");
	$nbtirages=$argv[5];//trim(fgets(STDIN,4096));

	for($i=1; $i<=$maxtirages; $i++) {
		$fd=fopen("script".$i.".sh","w");
//		fputs($fd,"cd Sommets\n");
		fputs($fd,"php -q ./unsommet.php ".$filename." ".$i." ".$nbtirages."\n");
		fclose($fd);
		system(sprintf("sh script%d.sh >/dev/null 2>/dev/null&\n",$i));
	}
}
break;

case "2":
//	fprintf(STDERR,"Are you on a SGI based cluster ? [y/N] ");
	$answer=$argv[2]; //trim(fgets(STDIN,4096));
	$answer=($answer == "y" || $answer == "Y")?"Y":"N";
	if ($answer == "N") {
//	fprintf(STDERR,"Remaining active processes : \n");
//	fprintf(STDERR,"----------------------\n");
	passthru("ps aux | grep \"sh script\"| grep -v \"grep\"");
//	fprintf(STDERR,"----------------------\n");
	} else {
//	fprintf(STDERR,"Remaining active nodes : \n");
//	fprintf(STDERR,"----------------------\n");
	passthru("qstat | grep script");
//	fprintf(STDERR,"----------------------\n");
	}
break;

case "5":
//	fprintf(STDERR,"Are you on a SGI based cluster ? [y/N] ");
	$answer=$argv[2];//trim(fgets(STDIN,4096));
	$answer=($answer == "y" || $answer == "Y")?"Y":"N";
	if ($answer == "N") {
//	fprintf(STDERR,"Remaining active processes : \n");
//	fprintf(STDERR,"----------------------\n");
	passthru("ps aux | grep \"sh script_AIO\"| grep -v \"grep\"");
//	fprintf(STDERR,"----------------------\n");
	} else {
//	fprintf(STDERR,"Remaining active nodes : \n");
//	fprintf(STDERR,"----------------------\n");
	passthru("qstat | grep script_AIO");
//	fprintf(STDERR,"----------------------\n");
	}
break;

case "3":
//fprintf(STDERR,"You must provide a .mdl file. Filename=");
$filename=$argv[2];//trim(fgets(STDIN,4096));
//fprintf(STDERR,"You must provide an output filename [eg. sortie.csv]. Filename=");
$outputfile=$argv[3];//trim(fgets(STDIN,4096));
system("php -q ./unsommet.php ".$filename." 0 0 > ".$outputfile);
break;

case "4":
	if (! file_exists("Partition_MinMax_on_vertices.txt")) {
//		fprintf(STDERR,"Error !!! Step 3) must have been launched defore step 4)"); 
		break;}
	$AllInputs=array();
	$AllOutputs=array();
	$AllSens=array(0,1);
	$Ttocompute=array();
	$fd=fopen("Partition_MinMax_on_vertices.txt","r");
	while($ligne=fgetcsv($fd,4096,";")) {
		list($in,$out)=explode("->",$ligne[0]);
		$AllInputs[$in]=1;
		$AllOutputs[$out]=1;
		if ($ligne[2] != $ligne[1]) $Ttocompute[]=array($in,$out); else {
			$fmm=fopen("MinMax_for_".$in."_to_".$out."_Results.tmp","w");
			fprintf($fmm,"%s->%s=%s for any vertices\n",$in,$out,$ligne[1]);
			fprintf($fmm,"%s->%s=%s for any vertices\n",$in,$out,$ligne[1]);
			fclose($fmm);
		}
	}
	$TInputs=array_keys($AllInputs);
	$TOutputs=array_keys($AllOutputs);

//	fprintf(STDERR,"Are you on a SGI based cluster ? [y/N] ");
	$answer=$argv[2];//trim(fgets(STDIN,4096));
	$answer=($answer == "y" || $answer == "Y")?"Y":"N";
	
	if ($answer == "N") {
	system("rm Modele_optimal*.mdl script_AIO*.sh\n");
//	fprintf(STDERR,"Maximum number of processes used (coarse grain parallization for a multicore computer) [20 is good] = ");
	$maxtirages=$argv[3];//trim(fgets(STDIN,4096));

	// Combien de choses à calculer ?
	$nbtocompute = count($Ttocompute); //count($TInputs)*count($TOutputs);
	$byprocessor = ceil($nbtocompute/$maxtirages);
	
	$computed=0;

	$numInput=0;
	$numOutput=0;
	
	for($i=1; $i<=$maxtirages; $i++) {
		$fd=fopen("script_AIO".$i.".sh","w");
		$k=0;
		$byprocessor = ceil(($nbtocompute-$computed)/($maxtirages-$i+1));
		do {
		if ($computed<$nbtocompute) { //if ($numInput*count($TOutputs)+$numOutput < $nbtocompute) {
			fprintf($fd,"php -q ./MinMax_Computation.php \"%s\" \"%s\" \"0\" > MinMax_for_%s_to_%s_Results.tmp\n",$Ttocompute[$computed][0],$Ttocompute[$computed][1],$Ttocompute[$computed][0],$Ttocompute[$computed][1]);
			fprintf($fd,"php -q ./MinMax_Computation.php \"%s\" \"%s\" \"1\" >> MinMax_for_%s_to_%s_Results.tmp\n",$Ttocompute[$computed][0],$Ttocompute[$computed][1],$Ttocompute[$computed][0],$Ttocompute[$computed][1]);
/*			fprintf($fd,"php ./MinMax_Computation.php \"%s\" \"%s\" \"0\" > MinMax_for_%s_to_%s_Results.tmp\n",$TInputs[$numInput],$TOutputs[$numOutput],$TInputs[$numInput],$TOutputs[$numOutput]);
			fprintf($fd,"php ./MinMax_Computation.php \"%s\" \"%s\" \"1\" >> MinMax_for_%s_to_%s_Results.tmp\n",$TInputs[$numInput],$TOutputs[$numOutput],$TInputs[$numInput],$TOutputs[$numOutput]);
*/			$computed++;
//			$numOutput++; if ($numOutput>=count($TOutputs)) {$numInput++; $numOutput=0;}
		}
		$k++;
		} while ($k<$byprocessor);
		fclose($fd);
		system(sprintf("sh script_AIO%d.sh >/dev/null 2>/dev/null&\n",$i));
		}
	} else {
	system("rm Modele_optimal*.mdl script_AIO*.sh pbtosolve.tmp\n");
//	fprintf(STDERR,"Maximum number of nodes used [100 is good] = ");
	$maxtirages=$argv[3];//trim(fgets(STDIN,4096));
	// Combien de choses à calculer ?
	$nbtocompute = count($Ttocompute); //count($TInputs)*count($TOutputs);
	$byprocessor = ceil($nbtocompute/$maxtirages);
	
	$numInput=0;
	$numOutput=0;
	$computed=0;
	
	for($i=1; $i<=$maxtirages; $i++) {
		$fd=fopen("script_AIO".$i.".sh","w");
		fputs($fd,"export PATH=\$PATH:/softs/local/php/current/bin\n");
		fputs($fd,"cd ".exec("pwd")."\n");
		$k=0;
		$byprocessor = ceil(($nbtocompute-$computed)/($maxtirages-$i+1));

		do {
		if ($computed<$nbtocompute) { //if ($numInput*count($TOutputs)+$numOutput < $nbtocompute) {
			fprintf($fd,"php -q ./MinMax_Computation.php \"%s\" \"%s\" \"0\" > MinMax_for_%s_to_%s_Results.tmp\n",$Ttocompute[$computed][0],$Ttocompute[$computed][1],$Ttocompute[$computed][0],$Ttocompute[$computed][1]);
			fprintf($fd,"php -q ./MinMax_Computation.php \"%s\" \"%s\" \"1\" >> MinMax_for_%s_to_%s_Results.tmp\n",$Ttocompute[$computed][0],$Ttocompute[$computed][1],$Ttocompute[$computed][0],$Ttocompute[$computed][1]);
/*			fprintf($fd,"php ./MinMax_Computation.php \"%s\" \"%s\" \"0\" > MinMax_for_%s_to_%s_Results.tmp\n",$TInputs[$numInput],$TOutputs[$numOutput],$TInputs[$numInput],$TOutputs[$numOutput]);
			fprintf($fd,"php ./MinMax_Computation.php \"%s\" \"%s\" \"1\" >> MinMax_for_%s_to_%s_Results.tmp\n",$TInputs[$numInput],$TOutputs[$numOutput],$TInputs[$numInput],$TOutputs[$numOutput]);
*/			$computed++;
//			$numOutput++; if ($numOutput>=count($TOutputs)) {$numInput++; $numOutput=0;}
		}
		$k++;
		} while ($k<$byprocessor);
		fclose($fd);
		system(sprintf("qsub -e /dev/null script_AIO%d.sh\n",$i));
//		system(sprintf("rm script_AIO%d.sh\n",$i));
	}
	}
	
break;

case 6:
	if (! file_exists("Partition_MinMax_on_vertices.txt")) {
//		fprintf(STDERR,"Error !!! Step 3) must have been launched defore step 4)"); 
		break;}
	$AllInputs=array();
	$AllOutputs=array();

	$fd=fopen("Partition_MinMax_on_vertices.txt","r");
	while($ligne=fgetcsv($fd,4096,";")) {
		list($in,$out)=explode("->",$ligne[0]);
		$AllInputs[$in]=1;
		$AllOutputs[$out]=1;
	}
	$TInputs=array_keys($AllInputs);
	$TOutputs=array_keys($AllOutputs);

//	fprintf(STDERR,"You must provide an output filename [eg. output_MinMax_AIO.csv]. Filename=");
	$outputfile=$argv[2];//trim(fgets(STDIN,4096));
	
	// Line 1
	
	$fd=fopen($outputfile,"w");
	$res="";
	for($i=0; $i<count($TInputs); $i++) {
		$res.=";Min ".$TInputs[$i].";Max ".$TInputs[$i];
	}
	fprintf($fd,"%s\n",$res);

	for($j=0; $j<count($TOutputs); $j++) {
		$res=$TOutputs[$j];
		for($i=0; $i<count($TInputs); $i++) {
			// lecture fichier
			$fin=fopen("MinMax_for_".$TInputs[$i]."_to_".$TOutputs[$j]."_Results.tmp","r");
			$ligne1=fgetcsv($fin,4096," ");
			$ligne2=fgetcsv($fin,4096," ");
			fclose($fin);
			
			
			list($inout,$valeurMin)=explode("=",$ligne1[0]);
			list($inout,$valeurMax)=explode("=",$ligne2[0]);
			if ($valeurMin == "") $valeurMin=0;
			if ($valeurMax == "") $valeurMax=0;
			// printf("%s to %s = (%s) --- (%s)\n",$TInputs[$i],$TOutputs[$j],$valeurMin,$valeurMax);
			$res.=";".$valeurMin.";".$valeurMax;
		}
		fprintf($fd,"%s\n",$res);
		//fprintf(STDERR,"%s\n",$res);

	}
	fclose($fd);
break;

default:
//	fprintf(STDERR,"Bad choice !");
}
?>
