<?php

//MinMax computation
set_time_limit(0);

include("Modele.php");


function Normalize(&$cur) {
	$somme=0;
	for($i=0; $i<count($cur); $i++) {$somme+=$cur[$i];}
	if($somme==0) $somme=1;
	for($i=0; $i<count($cur); $i++) {$cur[$i]/=$somme;}
}




// read several computed vertices

$AllModels=array();

$dir=opendir(".");

$nbmodels=0;
while ($fichier=readdir($dir)) {
	if (substr($fichier,0,strlen("Modele_Sommet_")) == "Modele_Sommet_") {
		$AllModels[$nbmodels]=new Modele();
		$AllModels[$nbmodels]->read($fichier);
		$nbmodels++;
	}
}

closedir($dir);

// Récupération des colonnes d'intérêt

$MonModele=new Modele();
$MonModele->read("Modele_Sommet_0.mdl");
/*
$MonModele2=new Modele();
$MonModele2->read("HB10good.mdl");
*/

$indicenoms=1;
$indiceId=0;
$indicesMetabolites=array();
for ($i=0; $i<count($MonModele->types_colonnes); $i++) {
	switch ($MonModele->types_colonnes[$i]) {
		case 2: $indiceId=$i; break;
		case 1: $indicenoms=$i; break;
		case 0:
		case 3:
		case 4:
		case 5:
		case 6:
		case 7:
		case 8:
			$indicesMetabolites[]=$i; break;		
		case 9:
			$indicesMetabolites[]=$i; 
			$indiceDistribution=$i;
			break;

	}
}

// Recherche de la distribution des carbones
$listeReactDist=array();
for($i=0; $i<count($MonModele->matrice_stoechiometrique); $i++) {
	if ($MonModele->matrice_stoechiometrique[$i][$indiceDistribution] != 0)
		$listeReactDist[]=$i;
}

if (count($listeReactDist) == 0) {
	echo "No Distribution to be computed !";
} else {
	foreach ($listeReactDist as $cleD => $valD) {
		
		$CarbonComposition=$MonModele->matrice_stoechiometrique[$valD];
		// calcul de Inr
		$inr=array();
		for($i=0; $i<count($MonModele->matrice_stoechiometrique); $i++) {
			if ($MonModele->equations_utilisees[$i+1] =="on") { // rustine
				$inr[$i]=array();
				$somme=0;
				for($j=0; $j<count($MonModele->types_colonnes); $j++) {
					if ($MonModele->types_colonnes[$j]>=3 && $MonModele->types_colonnes[$j]<=5) {
						$somme+=min(0,$MonModele->matrice_stoechiometrique[$i][$j]) * $CarbonComposition[$j];
					}
				}
				for($j=0; $j<count($MonModele->types_colonnes); $j++) {
					if ($MonModele->types_colonnes[$j]>=3 && $MonModele->types_colonnes[$j]<=5) {
						if ($somme != 0) 
							$inr[$i][$j]=-max(0,$MonModele->matrice_stoechiometrique[$i][$j]) * $CarbonComposition[$j] / $somme;
						else
							$inr[$i][$j]=0;
					}
				}
			}
		}
		
	}
}


// Optimisation

/*
$AllInputs=array();
$AllOutputs=array();
$AllSens=array(0,1);
$fd=fopen("Partition_MinMax_on_vertices.txt","r");
while($ligne=fgetcsv($fd,4096,";")) {
	list($in,$out)=explode("->",$ligne[0]);
	$AllInputs[$in]=1;
	$AllOutputs[$out]=1;
}


fclose($fd);
*/

$Input=$argv[1];
$Output=$argv[2];
$sens=$argv[3];

$maxverticesintoaccount=3;

$nbtirages=10;
$nbruns=200;
$nbnomove=5;
$minprec=0.001;

/*
foreach($AllInputs as $Input=>$val1) {
foreach($AllOutputs as $Output=>$val2) {
foreach($AllSens as $sens=>$val3) {
*/

//$sens=0; // Min=0, Max=1



$prec=0.1;

$MinMaxPart=array();

//$MonModele->getPartition($inr,$CarbonComposition, false, false, false, false, true, $MinMaxPart);
/*
for($i=0; $i<count($MonModele->Solution); $i++) {
	printf("%d;%f;%f;   (%s);(%s)   ;  (%s);(%s)\n",$i,$MonModele->Solution[$i],$MonModele2->Solution[$i], $MonModele->equations_utilisees[$i],$MonModele2->Entrees[$i],$MonModele->Sorties[$i],$MonModele2->Sorties[$i]);
}
//print_r($MonModele->Solution);
*/

//print_r($MinMaxPart);

$current=array(); 
$bestofall=array();

if ($sens==0) $bestopt=100000000; else $bestopt=-100000000;


for($vertices=1; $vertices<=$maxverticesintoaccount; $vertices++) {
for($tirages=0; $tirages<$nbtirages; $tirages++) {
	unset($MinMaxPart);
	$MinMaxPart=array();
	if ($sens==0) $currentopt=100000000; else $currentopt=-100000000;
	//fprintf(STDERR,"Restart no %d for vertice=%d\n",$tirages,$vertices);
	$prec=0.1;
	$nomove=0;
	
	// Starting vector v0
	//for($i=0; $i<$nbmodels; $i++) {$current[$i]=mt_rand()/mt_getrandmax();}
	
	// Starting vector v1
	//for($i=0; $i<$nbmodels; $i++) {$current[$i]=0;} $current[mt_rand()%$nbmodels]=1;
 	
	// Starting vector v2
	// for($i=0; $i<$nbmodels; $i++) {$current[$i]=0;} $current[$tirages%$nbmodels]=1;

 	// Starting vector v3 (middle of a face)
	for($i=0; $i<$nbmodels; $i++) {$current[$i]=0;} for ($i=0; $i<$vertices; $i++) $current[mt_rand()%$nbmodels]=1;

 	Normalize($current);
 	
	for($run=0; ($run<$nbruns && $nomove<$nbnomove); $run++) {
			// printf("run %d : nomove=%d, prec=%f, (%s)\n",$run,$nomove,$prec,implode(";",$current));
		// updatevector v0
		//$mvt=mt_rand()%$nbmodels; $signe=2*(mt_rand()%2)-1; $valeur=$signe*$prec+$current[$mvt]; if (($valeur>=0) && ($valeur<=1)) $current[$mvt]=$valeur;

		
		// updatevector v1
		do {$mvt=mt_rand()%$nbmodels;} while ($current[$mvt]<$prec); 
		do {$mvt2=mt_rand()%$nbmodels;} while ($mvt == $mvt2 && $current[$mvt2]>1-$prec);
		if ($current[$mvt]>=$prec && $current[$mvt2]<=1-$prec) {$current[$mvt]-=$prec; $current[$mvt2]+=$prec;}

		
		Normalize($current);
		
		
		
		// new model
		for($i=0; $i<$MonModele->NbEquations(); $i++) {
			$valeur=0;
			for($j=0; $j<$nbmodels; $j++) {
				$valeur+=$current[$j]*$AllModels[$j]->Solution[$i];
			}
			$MonModele->Solution[$i]=$valeur;
		}
		
		$MonModele->getPartition($inr,$CarbonComposition, false, false, false, false, true, $MinMaxPart);
		if (($sens == 0 && $MinMaxPart[$Input."->".$Output][$sens+2]<$currentopt) || ($sens == 1 && $MinMaxPart[$Input."->".$Output][$sens+2]>$currentopt)) {
			$currentopt=$MinMaxPart[$Input."->".$Output][$sens+2];
//			printf("(%d-%d, %f): %s->%s=%f (%s)\n",$tirages,$run, $prec, $Input,$Output,$currentopt,implode(";",$current));
			$nomove=0;
		} else {
			if (($valeur>=0) && ($valeur<=1)) $current[$mvt]-=$signe*$prec;
			$nomove++;
			if ($nomove >= $nbnomove && $prec > $minprec) {$nomove=0; $prec=$prec/10;}
		}
		//print_r($MinMaxPart[$Input."->".$Output]);
	}
	if (($sens == 0 && $currentopt<$bestopt) || ($sens == 1 && $bestopt<$currentopt)) {
		$bestopt=$currentopt;
		for($i=0; $i<count($current); $i++) $bestofall[$i]=$current[$i];
	}
}
}

printf("%s->%s=%f for (%s)\n",$Input,$Output,$bestopt,implode(";",$bestofall));


// Save the new model with appropriate supplementary constraints

$suppconstraints=array();
for($i=0; $i<$MonModele->NbEquations(); $i++) {
	$valeur=0;
	for($j=0; $j<$nbmodels; $j++) {
		$valeur+=$bestofall[$j]*$AllModels[$j]->Solution[$i];
	}
	$MonModele->Solution[$i]=sprintf("%.10f",$valeur);
	
	if ($MonModele->equations_utilisees[$i] =="on") {
		$suppconstraints[]="R_".$MonModele->matrice_stoechiometrique[$i-1][$indiceId]."=".sprintf("%.10f",$valeur);
	}
}
//print_r($suppconstraints);

for($i=0; $i<count($suppconstraints); $i++) {$MonModele->contraintes[]=$suppconstraints[$i];}

$MonModele->write("Modele_optimal_for_".(($sens==0)?"Min_":"Max_").$Input."_to_".$Output.".mdl");

//}}}

?>
