<?php
ini_set("memory_limit","512M");
set_time_limit(0);
error_reporting(E_ERROR | E_WARNING | E_PARSE);

function distance(&$T1,&$T2) {
	$res=0;
	if (count(T1) == count(T2)) {
		foreach($T1 as $cle=>$valeur) {
			if (isset($T2[$cle])) {
				if ($T2[$cle]<100000 && $valeur<10000) $res+=abs($T2[$cle]-$valeur);
			} else if ($valeur != "") $res+=1000000;
		}
	} else $res+=1000000;
	return $res;
}

function distanceE(&$T1,&$T2) {
	$res=0;
	for($i=0; $i<count($T1); $i++) $res+=($T1[$i]-$T2[$i])*($T1[$i]-$T2[$i]);
	return $res;
}


function ajouteUnique(&$T1,&$T2) {
	$i=0;
	while ($i<count($T1) && distance($T1[$i],$T2)>0.000001) {
		$i++;
	}
	if ($i == count($T1)) {
		$T1[]=$T2;
		return 0;
	} else {return 1;}
}



include("Modele.php");
include("simplex_solver.php");

$filename=$argv[1];
$number=$argv[2];
$nbtirages=$argv[3];



//printf("-- %s , %s \n",$filename,$number);

if ($number>0) {
$Modele=new Modele();

$Modele->read($filename);

$reactionsUtilisees=array();
$rustine=1;

	for ($i=0; $i<count($Modele->matrice_stoechiometrique); $i++) {
		if ($Modele->equations_utilisees[$i+$rustine] == "on") {$reactionsUtilisees[]=$i;
		}
	}

if (! file_exists("pbtosolve.tmp")) $Modele->ToLinearSystem("pbtosolve.tmp");

$Problem=new LinearProblem();

//$Problem->FromFile("sortiephp_1356535645.txt");
$Problem->FromFile("pbtosolve.tmp");


// $nbtirages=1;
$nbsommets=0;

$k=0;

for($nbsol=0; $nbsol<$nbtirages; $nbsol++) {
//fprintf(STDERR,"Sommet no".($nbsol+1)."\n");
// modification de l'objectif


$Problemetmp=$Problem;


for ($c=1; $c<=$Problemetmp->N; $c++) {
	$Problemetmp->setXY($Problemetmp->M,$c,20*(mt_rand()/mt_getrandmax()-0.5));
}


/*
$c=1+(floor($k/2)%($Problemetmp->N+2));
$signe=($k%2)*2-1;
$Problemetmp->setXY($Problemetmp->M,$c,$signe*mt_rand()/mt_getrandmax());
*/


$Basis=array();

$LPCODE=$Problemetmp->solve(false,	$Basis, 0);
// echo "Code=".$LPCODE."\n";
$Solution=array();
for($i=0; $i<count($Basis); $i++) {
  $Solution[$Basis[$i]]=$Problemetmp->getXY($i,0);
}

//print_r($Solution);

$Solution2=array();
for ($i = 0; $i < count($reactionsUtilisees); $i++) {
  //printf("R_%d = %f\n",$reactionsUtilisees[$i]+1,  $Solution[$i+1]);	
  if (isset($Solution[$i + 1])) {
    $Solution2[$reactionsUtilisees[$i] + 1] = $Solution[$i + 1];
  } else {
    $Solution2[$reactionsUtilisees[$i] + 1] = 0;
  }
}
//print_r($Solution2);




for($i=0; $i<count($Modele->equations_utilisees); $i++) 
	if (isset($Solution2[$i])) $Modele->Solution[$i]=$Solution2[$i]; else $Modele->Solution[$i]=0;

//$Modele->Solution[0]=$LPCODE;

/*
for($i=0; $i<count($Modele->equations_utilisees); $i++) {
	printf("%d R_%d %s (%s) (%s) -- (%s) (%s)\n",$i, $Modele->matrice_stoechiometrique[$i][0],$Modele->equations_utilisees[$i],$Solution2[$i],$Modele->Solution[$i],$Modele->Entrees[$i],$Modele->Sorties[$i]);
}
*/




//$Modele->write("essai.mdl");
$MonModele=$Modele;

/*
// Récupération des colonnes d'intérêt
$indicenoms=1;
$indiceId=0;
$indicesMetabolites=array();
for ($i=0; $i<count($MonModele->types_colonnes); $i++) {
	switch ($MonModele->types_colonnes[$i]) {
		case 2: $indiceId=$i; break;
		case 1: $indicenoms=$i; break;
		case 0:
		case 3:
		case 4:
		case 5:
		case 6:
		case 7:
		case 8:
			$indicesMetabolites[]=$i; break;		
		case 9:
			$indicesMetabolites[]=$i; 
			$indiceDistribution=$i;
			break;

	}
}

// Recherche de la distribution des carbones
$listeReactDist=array();
for($i=0; $i<count($MonModele->matrice_stoechiometrique); $i++) {
	if ($MonModele->matrice_stoechiometrique[$i][$indiceDistribution] != 0)
		$listeReactDist[]=$i;
}

if (count($listeReactDist) == 0) {
	echo "No Distribution to be computed !";
} else {
	foreach ($listeReactDist as $cleD => $valD) {
		
		$CarbonComposition=$MonModele->matrice_stoechiometrique[$valD];
		// calcul de Inr
		$inr=array();
		for($i=0; $i<count($MonModele->matrice_stoechiometrique); $i++) {
			if ($MonModele->equations_utilisees[$i+1] =="on") { // rustine
				$inr[$i]=array();
				$somme=0;
				for($j=0; $j<count($MonModele->types_colonnes); $j++) {
					if ($MonModele->types_colonnes[$j]>=3 && $MonModele->types_colonnes[$j]<=5) {
						$somme+=min(0,$MonModele->matrice_stoechiometrique[$i][$j]) * $CarbonComposition[$j];
					}
				}
				for($j=0; $j<count($MonModele->types_colonnes); $j++) {
					if ($MonModele->types_colonnes[$j]>=3 && $MonModele->types_colonnes[$j]<=5) {
						if ($somme != 0) 
							$inr[$i][$j]=-max(0,$MonModele->matrice_stoechiometrique[$i][$j]) * $CarbonComposition[$j] / $somme;
						else
							$inr[$i][$j]=0;
					}
				}
			}
		}
		
		//echo "<h1>Distribution computation for \"".$CarbonComposition[$indicenoms]."\"</h1>";
		$MonModele->getPartition($inr,$CarbonComposition, false, false, false, false, true, $MinMaxPart);

		
		
//		echo "<h1>Latex distribution computation for \"".$CarbonComposition[$indicenoms]."\"</h1>";
//		$MonModele->getPartitionLatex($inr,$CarbonComposition, true, true, true, true);

		
//		echo "<h1>Sage distribution computation for \"".$CarbonComposition[$indicenoms]."\"</h1>";
//		$MonModele->getPartitionSage($inr,$CarbonComposition, true, true, true, true);
	}
	*/
//}


if ($LPCODE == 0) { //(ajouteUnique($ToutesSolutions,$Solution2) == 0) {
	$nbsommets++;
/*
	$fd=fopen("solutions_calculees_".$number."_".$nbsol.".txt","w");
	for($i=0; $i<$Modele->NbEquations(); $i++) {
  		fprintf($fd,"%s%f",($i>0)?";":"",($Modele->equations_utilisees[$i] == "on")?$Modele->Solution[$i]:0);
  	}
  	
  	fclose($fd);
*/
	$Modele->write("solutions_calculees_".$number."_".$nbsol.".txt");

/*  	
	$fd=fopen("Partition_calculees_".$number."_".$nbsol.".txt","w");
	foreach($MinMaxPart as $cle=>$valeur) {
  		fprintf($fd,"%s;%f;%f\n",$cle,$valeur[0],$valeur[1]);
  	}
  	fclose($fd);
*/  	
}
$k++;

//fprintf(STDERR,"NbSommets = %d\n",$nbsommets);
}
} else {

$ToutesSolutions=array();
$nbsol=0;

$dir=opendir(".");

$tmpmodel=new Modele();

$fileno=0;
while ($fichier=readdir($dir)) {
	if (substr($fichier,0,strlen("solutions_calculees")) == "solutions_calculees") {

/*
$fd=fopen($fichier,"r");
		while ($ligne=fgetcsv($fd,4096,";")) {$ToutesSolutions[$nbsol++]=$ligne;}
		fclose($fd);
*/
	$tmpmodel->read($fichier);
	$ToutesSolutions[$nbsol]=new Modele(); $ToutesSolutions[$nbsol]->read($fichier);
//	$ToutesSolutions[$nbsol]=$tmpmodel->Solutions;
	$nbsol++;
	
	}
$fileno++;
if ($fileno%10 == 0) {
$ToutesSolReal=array();
$nbsolreal=0;

for($i=0; $i<count($ToutesSolutions); $i++) {
	$sol1=$ToutesSolutions[$i]->Solution; 
	$distancemin=1000;
	for($j=0; $j<$i; $j++) {
		$sol2=$ToutesSolutions[$j]->Solution; 
		$distancecourante=distanceE($sol1,$sol2);
		if ($distancecourante<$distancemin) $distancemin=$distancecourante;
		//fprintf(STDERR,";%f",$distancecourante);
	}
	if ($distancemin>0.5) {$ToutesSolReal[$nbsolreal++]=$ToutesSolutions[$i]; } else {unset($ToutesSolutions[$i]);}
}
unset($ToutesSolutions);
$ToutesSolutions=$ToutesSolReal;
$nbsol=count($ToutesSolReal);
}

}


$ToutesSolReal=array();
$nbsolreal=0;

for($i=0; $i<count($ToutesSolutions); $i++) {
	$sol1=$ToutesSolutions[$i]->Solution; 
	$distancemin=1000;
	for($j=0; $j<$i; $j++) {
		$sol2=$ToutesSolutions[$j]->Solution; 
		$distancecourante=distanceE($sol1,$sol2);
		if ($distancecourante<$distancemin) $distancemin=$distancecourante;
		//fprintf(STDERR,";%f",$distancecourante);
	}
	if ($distancemin>0.5) {$ToutesSolReal[$nbsolreal++]=$ToutesSolutions[$i]; } else {unset($ToutesSolutions[$i]);}
}

echo "Total de ".count($ToutesSolReal)."\n";


$Modele=new Modele();
$Modele->read($filename);

$MonModele=$Modele;

// Récupération des colonnes d'intérêt
$indicenoms=1;
$indiceId=0;
$indicesMetabolites=array();
for ($i=0; $i<count($MonModele->types_colonnes); $i++) {
	switch ($MonModele->types_colonnes[$i]) {
		case 2: $indiceId=$i; break;
		case 1: $indicenoms=$i; break;
		case 0:
		case 3:
		case 4:
		case 5:
		case 6:
		case 7:
		case 8:
			$indicesMetabolites[]=$i; break;		
		case 9:
			$indicesMetabolites[]=$i; 
			$indiceDistribution=$i;
			break;

	}
}

// Recherche de la distribution des carbones
$listeReactDist=array();
for($i=0; $i<count($MonModele->matrice_stoechiometrique); $i++) {
	if ($MonModele->matrice_stoechiometrique[$i][$indiceDistribution] != 0)
		$listeReactDist[]=$i;
}

if (count($listeReactDist) == 0) {
	echo "No Distribution to be computed !";
} else {
	foreach ($listeReactDist as $cleD => $valD) {
		
		$CarbonComposition=$MonModele->matrice_stoechiometrique[$valD];
		// calcul de Inr
		$inr=array();
		for($i=0; $i<count($MonModele->matrice_stoechiometrique); $i++) {
			if ($MonModele->equations_utilisees[$i+1] =="on") { // rustine
				$inr[$i]=array();
				$somme=0;
				for($j=0; $j<count($MonModele->types_colonnes); $j++) {
					if ($MonModele->types_colonnes[$j]>=3 && $MonModele->types_colonnes[$j]<=5) {
						$somme+=min(0,$MonModele->matrice_stoechiometrique[$i][$j]) * $CarbonComposition[$j];
					}
				}
				for($j=0; $j<count($MonModele->types_colonnes); $j++) {
					if ($MonModele->types_colonnes[$j]>=3 && $MonModele->types_colonnes[$j]<=5) {
						if ($somme != 0) 
							$inr[$i][$j]=-max(0,$MonModele->matrice_stoechiometrique[$i][$j]) * $CarbonComposition[$j] / $somme;
						else
							$inr[$i][$j]=0;
					}
				}
			}
		}
		
		//echo "<h1>Distribution computation for \"".$CarbonComposition[$indicenoms]."\"</h1>";
//		echo "<h1>Latex distribution computation for \"".$CarbonComposition[$indicenoms]."\"</h1>";
//		$MonModele->getPartitionLatex($inr,$CarbonComposition, true, true, true, true);

		
//		echo "<h1>Sage distribution computation for \"".$CarbonComposition[$indicenoms]."\"</h1>";
//		$MonModele->getPartitionSage($inr,$CarbonComposition, true, true, true, true);
	}
}


$MinMaxPart=array();


//print_r($ToutesSolReal[0]);



for($i=0; $i<count($ToutesSolReal); $i++) {
	$MinMaxPart2=array();
	$MonModele=$ToutesSolReal[$i];
	$MonModele->write("Modele_Sommet_".$i.".mdl");
	$MonModele->getPartition($inr,$CarbonComposition, false, false, false, false, true, $MinMaxPart2);	

	$fd=fopen("Partition_calculees_".$i.".txt","w");
	foreach($MinMaxPart2 as $cle=>$valeur) {
  		fprintf($fd,"%s;%f;%f;%f\n",$cle,$valeur[0],$valeur[2],$valeur[4]);
  	}
  	fclose($fd);
	
	$MonModele->getPartition($inr,$CarbonComposition, false, false, false, false, true, $MinMaxPart);	
	printf("%s\n",implode(";",$MonModele->Solution));
}


	$fd=fopen("Partition_MinMax_on_vertices.txt","w");
	foreach($MinMaxPart as $cle=>$valeur) {
  		fprintf($fd,"%s;%f;%f;%f;%f;%f;%f\n",$cle,$valeur[0],$valeur[1],$valeur[2],$valeur[3],$valeur[4],$valeur[5]);
  	}
  	fclose($fd);



}

?>
